-- <ScriptOptions statementTerminator="@" />
DROP TRIGGER D_ITM_DELETE@
CREATE TRIGGER D_ITM_DELETE
	AFTER DELETE ON TCTG_ITM_ITEM
	REFERENCING  OLD AS OLD
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC
    DECLARE EVENT_ID INTEGER DEFAULT 0;
    DECLARE CATALOG_NAME VARCHAR(100);
    DECLARE ROLLBACK_DELETE INTEGER;
    DECLARE ITD_ITEM_ID INTEGER;
    DECLARE CATALOG_TYPE VARCHAR(100);
    DECLARE COMPANY_CODE VARCHAR(20);
    DECLARE LOG_LEVEL CHAR(1);
    SET COMPANY_CODE = (SELECT CMP_COMPANY_CODE FROM CMP WHERE CMP_COMPANY_ID = OLD.ITM_COMPANY_ID);
	SET (CATALOG_NAME, CATALOG_TYPE) = (SELECT CTG_NAME, CTG_TYPE FROM CTG WHERE CTG_ID = OLD.ITM_CONTAINER_ID);
	
	SET LOG_LEVEL = (SELECT DLC_LOG_LEVEL FROM TDCL_DLC_DATACHANGE_CONFIG 
							WHERE DLC_CONTAINER_NAME = CATALOG_NAME 
							AND DLC_CONTAINER_TYPE = CATALOG_TYPE
							AND DLC_COMPANY_CODE= COMPANY_CODE
							AND DLC_ENABLED = 'Y');

	IF LOG_LEVEL IS NOT NULL THEN
	    IF CATALOG_TYPE = 'CATALOG' THEN
		    IF OLD.ITM_NEXT_VERSION_ID = 999999999 THEN
		    SET ITD_ITEM_ID = (SELECT ITD_ITEM_ID FROM ITD WHERE ITD_ITEM_ID = OLD.ITM_ID AND ITD_NEXT_VERSION_ID = OLD.ITM_NEXT_VERSION_ID
		    AND ITD_VERSION_ID = OLD.ITM_VERSION_ID);
		    	IF ITD_ITEM_ID IS NOT NULL  THEN 
		    	INSERT INTO TDCL_IEL_ITEM_EVENT_LOG VALUES
				  	(
				  		NEXTVAL FOR QDCL_IEL_EVENT_ID,
				  		COMPANY_CODE,
				  		OLD.ITM_ID,
				  		CATALOG_NAME,
				  		NULL,
				  		'D',
				  		OLD.ITM_PRIMARY_KEY,
				  		OLD.ITM_VERSION_ID,
				  		OLD.ITM_NEXT_VERSION_ID,
				  		OLD.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
				  	);
				  ELSE
				  	INSERT INTO TDCL_IEL_ITEM_EVENT_LOG VALUES
				  	(
				  		NEXTVAL FOR QDCL_IEL_EVENT_ID,
				  		COMPANY_CODE,
				  		OLD.ITM_ID,
				  		CATALOG_NAME,
				  		NULL,
				  		'R',
				  		OLD.ITM_PRIMARY_KEY,
				  		OLD.ITM_VERSION_ID,
				  		OLD.ITM_NEXT_VERSION_ID,
				  		OLD.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
				  	);
				  END IF;
			END IF ;
		ELSEIF CATALOG_TYPE = 'LOOKUP_TABLE' THEN
			IF OLD.ITM_NEXT_VERSION_ID = 999999999 THEN
			    SET ITD_ITEM_ID = (SELECT ITD_ITEM_ID FROM ITD WHERE ITD_ITEM_ID = OLD.ITM_ID AND ITD_NEXT_VERSION_ID = OLD.ITM_NEXT_VERSION_ID
			    AND ITD_VERSION_ID = OLD.ITM_VERSION_ID);
		    	
		    	IF ITD_ITEM_ID IS NOT NULL THEN 
					INSERT INTO TDCL_LEL_LKP_ENTRY_EVENT_LOG VALUES
				  	(
				  		NEXTVAL FOR QDCL_LEL_EVENT_ID,
				  		COMPANY_CODE,
				  		OLD.ITM_ID,
				  		CATALOG_NAME,
				  		NULL,
				  		'D',
				  		OLD.ITM_PRIMARY_KEY,
				  		OLD.ITM_VERSION_ID,
				  		OLD.ITM_NEXT_VERSION_ID,
				  		OLD.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
				  	);
				  ELSE
				  	INSERT INTO TDCL_LEL_LKP_ENTRY_EVENT_LOG VALUES
				  	(
				  		NEXTVAL FOR QDCL_LEL_EVENT_ID,
				  		COMPANY_CODE,
				  		OLD.ITM_ID,
				  		CATALOG_NAME,
				  		NULL,
				  		'R',
				  		OLD.ITM_PRIMARY_KEY,
				  		OLD.ITM_VERSION_ID,
				  		OLD.ITM_NEXT_VERSION_ID,
				  		OLD.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
				  	);
				  END IF;
			END IF ;
		END IF;
	END IF;
  END@
