-- <ScriptOptions statementTerminator="@" />
SET CURRENT SQLID=<SCHEMA>@      
DROP TRIGGER U_ITM_UPDATE@
-- <ScriptOptions statementTerminator="@" />
CREATE TRIGGER U_ITM_UPDATE 
	AFTER UPDATE ON TCTG_ITM_ITEM
	REFERENCING  NEW AS NEW
		OLD AS OLD
	FOR EACH ROW MODE DB2SQL
BEGIN ATOMIC
    DECLARE EVENT_ID INTEGER DEFAULT 0;
    DECLARE CATALOG_NAME VARCHAR(100);
    DECLARE CATALOG_TYPE VARCHAR(100);
	DECLARE COMPANY_CODE VARCHAR(20);
	DECLARE LOG_LEVEL CHAR(1);
	
	SET COMPANY_CODE = (SELECT CMP_COMPANY_CODE FROM CMP WHERE CMP_COMPANY_ID = OLD.ITM_COMPANY_ID);
	SET (CATALOG_NAME, CATALOG_TYPE) = (SELECT CTG_NAME, CTG_TYPE FROM CTG WHERE CTG_ID = OLD.ITM_CONTAINER_ID);
	SET LOG_LEVEL = (SELECT DLC_LOG_LEVEL FROM TDCL_DLC_DATACHANGE_CONFIG 
							WHERE DLC_CONTAINER_NAME = CATALOG_NAME 
							AND DLC_CONTAINER_TYPE = CATALOG_TYPE
							AND DLC_COMPANY_CODE= COMPANY_CODE							AND DLC_ENABLED = 'Y');
	IF LOG_LEVEL IS NOT NULL THEN
	
	    IF CATALOG_TYPE = 'CATALOG' THEN
	    			IF NEW.ITM_NEXT_VERSION_ID = 999999999 AND OLD.ITM_NEXT_VERSION_ID = -2 THEN
	
		     SET EVENT_ID = (SELECT MAX(IEL_EVENT_ID) FROM TDCL_IEL_ITEM_EVENT_LOG 
				  					WHERE IEL_NEXT_VERSION_ID = 999999999
				  						AND IEL_ITEM_ID = NEW.ITM_ID 
				  						AND IEL_EVENT_TYPE = 'D'
				  						AND IEL_PRIMARY_KEY IS NULL);
						  	 IF EVENT_ID IS NULL  THEN 	  			
						INSERT INTO TDCL_IEL_ITEM_EVENT_LOG VALUES
					  	(
					  		NEXTVAL FOR QDCL_IEL_EVENT_ID,
					  		COMPANY_CODE,
					  		NEW.ITM_ID,
					  		CATALOG_NAME,
					  		NEW.ITM_PRIMARY_KEY,
					  		'I',
					  		NULL,
					  		NEW.ITM_VERSION_ID,
					  		NEW.ITM_NEXT_VERSION_ID,
					  		NEW.ITM_LAST_MODIFIED,
							CURRENT_TIMESTAMP
					  	);
							 ELSE
				 	 	UPDATE TDCL_IEL_ITEM_EVENT_LOG SET 
					 	IEL_PRIMARY_KEY = NEW.ITM_PRIMARY_KEY, 
					 	IEL_EVENT_TYPE = 'U', 
					 	IEL_VERSION_ID = NEW.ITM_VERSION_ID,
					 	IEL_NEXT_VERSION_ID = NEW.ITM_NEXT_VERSION_ID,
					 	IEL_LAST_MODIFIED_TIME = NEW.ITM_LAST_MODIFIED,
						IEL_EVENT_TIME = CURRENT_TIMESTAMP
						WHERE IEL_EVENT_ID = EVENT_ID;
					END IF;
				    ELSEIF NEW.ITM_NEXT_VERSION_ID = 999999999 AND OLD.ITM_NEXT_VERSION_ID != 999999999 THEN
		    	 SET EVENT_ID = (SELECT MAX(IEL_EVENT_ID) FROM TDCL_IEL_ITEM_EVENT_LOG 
				  					WHERE IEL_NEXT_VERSION_ID = 999999999
				  						AND IEL_ITEM_ID = NEW.ITM_ID 
				  						AND IEL_EVENT_TYPE = 'R'
				  						AND IEL_PRIMARY_KEY IS NULL);
				  
					 IF EVENT_ID IS NULL  THEN 	  			
						INSERT INTO TDCL_IEL_ITEM_EVENT_LOG VALUES
					  	(
					  		NEXTVAL FOR QDCL_IEL_EVENT_ID,
					  		COMPANY_CODE,
					  		NEW.ITM_ID,
					  		CATALOG_NAME,
					  		NEW.ITM_PRIMARY_KEY,
					  		'R',
					  		OLD.ITM_PRIMARY_KEY,
					  		NEW.ITM_VERSION_ID,
					  		NEW.ITM_NEXT_VERSION_ID,
					  		NEW.ITM_LAST_MODIFIED,
							CURRENT_TIMESTAMP
					  	);
					 ELSE
				 	 	UPDATE TDCL_IEL_ITEM_EVENT_LOG SET 
					 	IEL_PRIMARY_KEY = NEW.ITM_PRIMARY_KEY, 
					 	IEL_EVENT_TYPE = 'R', 
					 	IEL_VERSION_ID = NEW.ITM_VERSION_ID,
					 	IEL_NEXT_VERSION_ID = NEW.ITM_NEXT_VERSION_ID,
					 	IEL_LAST_MODIFIED_TIME = NEW.ITM_LAST_MODIFIED,
						IEL_EVENT_TIME = CURRENT_TIMESTAMP
						WHERE IEL_EVENT_ID = EVENT_ID;
					END IF;
									ELSEIF NEW.ITM_NEXT_VERSION_ID != 999999999 AND OLD.ITM_NEXT_VERSION_ID = 999999999 THEN
					INSERT INTO TDCL_IEL_ITEM_EVENT_LOG VALUES
					(
				  		NEXTVAL FOR QDCL_IEL_EVENT_ID,
				  		COMPANY_CODE,
				  		OLD.ITM_ID,
				  		CATALOG_NAME,
				  		NULL,
				  		'D',
				  		OLD.ITM_PRIMARY_KEY,
				  		OLD.ITM_VERSION_ID,
				  		OLD.ITM_NEXT_VERSION_ID,
				  		OLD.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
					);
			END IF ;
			ELSEIF CATALOG_TYPE = 'LOOKUP_TABLE' THEN
			IF NEW.ITM_NEXT_VERSION_ID = 999999999 AND OLD.ITM_NEXT_VERSION_ID = -2 THEN
	    	 SET EVENT_ID = (SELECT MAX(LEL_EVENT_ID) FROM TDCL_LEL_LKP_ENTRY_EVENT_LOG 
			  					WHERE LEL_NEXT_VERSION_ID = 999999999
			  						AND LEL_LKP_ENTRY_ID = NEW.ITM_ID 
			  						AND LEL_EVENT_TYPE = 'D'
			  						AND LEL_PRIMARY_KEY IS NULL);
			  	 IF EVENT_ID IS NULL  THEN 	  			
					INSERT INTO TDCL_LEL_LKP_ENTRY_EVENT_LOG VALUES
				  	(
				  		NEXTVAL FOR QDCL_LEL_EVENT_ID,
				  		COMPANY_CODE,
				  		NEW.ITM_ID,
				  		CATALOG_NAME,
				  		NEW.ITM_PRIMARY_KEY,
				  		'I',
				  		NULL,
				  		NEW.ITM_VERSION_ID,
				  		NEW.ITM_NEXT_VERSION_ID,
				  		NEW.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
				  	);
				 ELSE
			 	 	UPDATE TDCL_LEL_LKP_ENTRY_EVENT_LOG SET 
				 	LEL_PRIMARY_KEY = NEW.ITM_PRIMARY_KEY, 
				 	LEL_EVENT_TYPE = 'U', 
				 	LEL_VERSION_ID = NEW.ITM_VERSION_ID,
				 	LEL_NEXT_VERSION_ID = NEW.ITM_NEXT_VERSION_ID,
				 	LEL_LAST_MODIFIED_TIME = NEW.ITM_LAST_MODIFIED,
					LEL_EVENT_TIME = CURRENT_TIMESTAMP
					WHERE LEL_EVENT_ID = EVENT_ID;
				END IF;
	    ELSEIF NEW.ITM_NEXT_VERSION_ID = 999999999 AND OLD.ITM_NEXT_VERSION_ID != 999999999 THEN
	    	 SET EVENT_ID = (SELECT MAX(LEL_EVENT_ID) FROM TDCL_LEL_LKP_ENTRY_EVENT_LOG 
			  					WHERE LEL_NEXT_VERSION_ID = 999999999
			  						AND LEL_LKP_ENTRY_ID = NEW.ITM_ID 
			  						AND LEL_EVENT_TYPE = 'R'
			  						AND LEL_PRIMARY_KEY IS NULL);
			  
				 IF EVENT_ID IS NULL  THEN 	  			
					INSERT INTO TDCL_LEL_LKP_ENTRY_EVENT_LOG VALUES
				  	(
				  		NEXTVAL FOR QDCL_LEL_EVENT_ID,
				  		COMPANY_CODE,
				  		NEW.ITM_ID,
				  		CATALOG_NAME,
				  		NEW.ITM_PRIMARY_KEY,
				  		'R',
				  		OLD.ITM_PRIMARY_KEY,
				  		NEW.ITM_VERSION_ID,
				  		NEW.ITM_NEXT_VERSION_ID,
				  		NEW.ITM_LAST_MODIFIED,
						CURRENT_TIMESTAMP
				  	);
				 ELSE
			 	 	UPDATE TDCL_LEL_LKP_ENTRY_EVENT_LOG SET 
				 	LEL_PRIMARY_KEY = NEW.ITM_PRIMARY_KEY, 
				 	LEL_EVENT_TYPE = 'R', 
				 	LEL_VERSION_ID = NEW.ITM_VERSION_ID,
				 	LEL_NEXT_VERSION_ID = NEW.ITM_NEXT_VERSION_ID,
				 	LEL_LAST_MODIFIED_TIME = NEW.ITM_LAST_MODIFIED,
					LEL_EVENT_TIME = CURRENT_TIMESTAMP
					WHERE LEL_EVENT_ID = EVENT_ID;
				END IF;
		ELSEIF NEW.ITM_NEXT_VERSION_ID != 999999999 AND OLD.ITM_NEXT_VERSION_ID = 999999999 THEN
				INSERT INTO TDCL_LEL_LKP_ENTRY_EVENT_LOG VALUES
				(
			  		NEXTVAL FOR QDCL_LEL_EVENT_ID,
			  		COMPANY_CODE,
			  		OLD.ITM_ID,
			  		CATALOG_NAME,
			  		NULL,
			  		'D',
			  		OLD.ITM_PRIMARY_KEY,
			  		OLD.ITM_VERSION_ID,
			  		OLD.ITM_NEXT_VERSION_ID,
			  		OLD.ITM_LAST_MODIFIED,
					CURRENT_TIMESTAMP
				);
			END IF ;
		END IF;	
	END IF;
  END@

