DROP TRIGGER "D_CAT_DELETE";

CREATE TRIGGER D_CAT_DELETE
	AFTER DELETE ON "TCTG_CAT_CATEGORY"
	REFERENCING  OLD AS OLD
	FOR EACH ROW
  DECLARE
  EVENT_ID INTEGER DEFAULT 0;
  HIER_NAME VARCHAR2(100);
  ROLLBACK_DELETE INTEGER;
  HIER_TYPE VARCHAR2(100);
  COMPANY_CODE VARCHAR2(20);
  LOG_LEVEL INTEGER;

BEGIN
    SELECT CTR_NAME,
      CASE CTR_TYPE
				WHEN 'CATEGORY_TREE' THEN 'HIERARCHY'
				ELSE CTR_TYPE
      END
      INTO HIER_NAME, HIER_TYPE
    FROM CTR WHERE CTR_ID = :OLD.CAT_CONTAINER_ID
             AND CTR_COMPANY_ID = :OLD.CAT_COMPANY_ID;
		SELECT CMP_COMPANY_CODE INTO COMPANY_CODE FROM CMP WHERE CMP_COMPANY_ID = :OLD.CAT_COMPANY_ID;
  	SELECT COUNT(*) INTO LOG_LEVEL FROM TDCL_DLC_DATACHANGE_CONFIG WHERE DLC_CONTAINER_NAME = HIER_NAME AND DLC_CONTAINER_TYPE = HIER_TYPE AND DLC_COMPANY_CODE = COMPANY_CODE	AND DLC_ENABLED = 'Y';
	IF LOG_LEVEL > 0 THEN

	    IF :OLD.CAT_NEXT_VERSION_ID = 999999999 THEN
	    	SELECT COUNT(*) INTO ROLLBACK_DELETE FROM CHI WHERE CHI_CHILD_ID = :OLD.CAT_ID AND CHI_NEXT_VERSION_ID = 999999999;

	    	IF ROLLBACK_DELETE > 0 THEN
				INSERT INTO TDCL_CEL_CATEGORY_EVENT_LOG VALUES
			  	(
			  		QDCL_CEL_EVENT_ID.NEXTVAL,
			  		COMPANY_CODE,
			  		:OLD.CAT_ID,
			  		HIER_NAME,
			  		NULL,
			  		'U',
			  		:OLD.CAT_PRIMARY_KEY,
			  		:OLD.CAT_VERSION_ID,
			  		:OLD.CAT_NEXT_VERSION_ID,
			  		:OLD.CAT_LAST_MODIFIED,
			  		CURRENT_TIMESTAMP
			  	);
			 ELSE
			  	INSERT INTO TDCL_CEL_CATEGORY_EVENT_LOG VALUES
			  	(
			  		QDCL_CEL_EVENT_ID.NEXTVAL,
			  		COMPANY_CODE,
			  		:OLD.CAT_ID,
			  		HIER_NAME,
			  		NULL,
			  		'D',
			  		:OLD.CAT_PRIMARY_KEY,
			  		:OLD.CAT_VERSION_ID,
			  		:OLD.CAT_NEXT_VERSION_ID,
			  		:OLD.CAT_LAST_MODIFIED,
			  		CURRENT_TIMESTAMP
			  	);
			 END IF;
		END IF ;
	END IF;
  END;
/
