# Copyright  IBM Corp. 2008 - All Rights Reserved.
# IBM makes no representations or warranties about the suitability of
# this program, either express or implied, including but not limited to
# the implied warranties of merchantability, fitness for a particular
# purpose, or non-infringement.

import sys

def setJVMArguments(nodename, servername, args):
		
		#set the scope
		scope = []
		scope.extend(['-nodeName', nodename])
		scope.extend(['-serverName', servername])
		
		# get the existing value
		cmdParams = []
		cmdParams.extend(scope)
		cmdParams.extend(['-propertyName', 'genericJvmArguments'])
		curJvmArgStr = AdminTask.showJVMProperties(cmdParams)
		
		#append the new value to current value 
		newJvmArgs = []
		if len(curJvmArgStr) != 0:
			newJvmArgs.append(curJvmArgStr)
		newJvmArgs.extend(args)
		newJvmArgStr = "\"" + " ".join(newJvmArgs) + "\""
		
		#set the new value
		cmdParams = []
		cmdParams.extend(scope)
		cmdParams.extend(['-genericJvmArguments', newJvmArgStr])
		cmdParamStr = " ".join(cmdParams)
		AdminTask.setGenericJVMArguments(cmdParamStr)		
		AdminConfig.save()



#Main
if len(sys.argv) < 3:
	print "This script requires 3 parameters \"nodename\", \"servername\" and \"newjvmargs\""
else:
	nodename = sys.argv[0]
	servername= sys.argv[1]
	newargs = sys.argv[2:]
	setJVMArguments(nodename, servername, newargs)
