/*********************************************** {COPYRIGHT-TOP} ***
* IBM Confidential
* OCO Source Materials
* 5724-V51
*
* (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
*
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has been
* deposited with the U.S. Copyright Office.
************************************************ {COPYRIGHT-END} **/



/**
 *  Copyright IBM Corp. and other(s) 2000, 2008 All Rights Reserved. 
 *
 * The following sample of source code ("Sample Code") is owned by International Business Machines Corporation or 
 * one of its subsidiaries ("IBM") and is copyrighted and licensed, not sold.
 * You may use, copy, modify, and distribute the Sample Code in any form without payment to IBM, for the purpose of assisting you in the development of your applications.

 * The Sample Code is provided to you on an "AS IS" basis, without warranty of any kind. 
 * IBM HEREBY EXPRESSLY DISCLAIMS ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * Some jurisdictions do not allow for the exclusion or limitation of implied warranties, so the above limitations or exclusions may not apply to you. 
 * IBM shall not be liable for any damages you suffer as a result of using, copying, modifying or distributing the Sample Code, even if IBM has been advised of the possibility of such damages.
 **/
package com.ibm.ccd.loader;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.Reader;
import java.sql.SQLException;

public class CSVLoader extends DataProcessor{

	private String dataFile;

	public CSVLoader(String sPropFile, String sDataFile)throws FileNotFoundException,IOException,Exception
	{
		super(sPropFile); 
		dataFile = sDataFile;             
	}     

	/***
	 * Uses CSVParser to parse each line of the CSV file, and initialize the catalog and
	 * the categories from the data file
	 * @throws FileNotFoundException - When the file(data file or the property file) does not exist
	 * @throws IOException - occurs when parsing the files
	 * @throws Exception - when getting the context
	 */
	public void loadData() throws FileNotFoundException,IOException,SQLException,Exception
	{ 

		boolean bDone = false;
		String[] arg;
		int jobId = 0;
		int currentRecordId =0;
		String name;
		String value;

		//Data file can be a Document in the docstore or a file in the filesystem, so get the appropriate reader.           
		Reader reader = ProcessorUtils.getReader(dataFile);
		SimpleCSVParser parser= new SimpleCSVParser(reader);                   
		//skipping the header line of the CSV formatted data file
		parser.skipLine();	

		while (!bDone)
		{
			arg = parser.splitLine();
			bDone = (arg == null);                          
			if (arg != null)
			{                	  
				jobId = Integer.valueOf(arg[0]);
				currentRecordId = Integer.valueOf(arg[1]);                      
				name = arg[2];                    
				value = arg[3];  
				processRow(jobId, currentRecordId, name, value);
			}
		}
		finishUpLoadData(jobId, currentRecordId);		
	}

}



