/*********************************************** {COPYRIGHT-TOP} ***
* IBM Confidential
* OCO Source Materials
* 5724-V51
*
* (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
*
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has been
* deposited with the U.S. Copyright Office.
************************************************ {COPYRIGHT-END} **/



/**
 *  Copyright IBM Corp. and other(s) 2000, 2008 All Rights Reserved. 
 *
 * The following sample of source code ("Sample Code") is owned by International Business Machines Corporation or 
 * one of its subsidiaries ("IBM") and is copyrighted and licensed, not sold.
 * You may use, copy, modify, and distribute the Sample Code in any form without payment to IBM, for the purpose of assisting you in the development of your applications.

 * The Sample Code is provided to you on an "AS IS" basis, without warranty of any kind. 
 * IBM HEREBY EXPRESSLY DISCLAIMS ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * Some jurisdictions do not allow for the exclusion or limitation of implied warranties, so the above limitations or exclusions may not apply to you. 
 * IBM shall not be liable for any damages you suffer as a result of using, copying, modifying or distributing the Sample Code, even if IBM has been advised of the possibility of such damages.
 **/
package com.ibm.ccd.loader;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.ibm.ccd.loader.ProcessorUtils;

public class DatabaseLoader extends DataProcessor{

	private int jobId, startRecId,stopRecId;     
	private Connection dataTableConnObj;

	private static final String DATA_TABLE_NAME = "tldr_dat_data_table";

	public DatabaseLoader(String sPropFile, int sJobId, int beginRecId, int endRecId) throws FileNotFoundException,IOException,Exception
	{
		super(sPropFile);
		jobId = sJobId;
		startRecId = beginRecId;
		stopRecId = endRecId;
		dataTableConnObj = ProcessorUtils.getConnection();            
	}     

	/***
	 * 
	 * @throws FileNotFoundException - When the file(data file or the property file) does not exist
	 * @throws SQLException - while loading data from the table
	 * @throws PIMAuthorizationException - when user is not Aythorized to do the operation
	 */
	public void loadData() throws FileNotFoundException,SQLException,Exception
	{              
		int currentRecordId = 0;
		String name;
		String value;
		//Query String to get the data corresponding to the JobId, Start and the Stop Record id
		String getRecordQuery =  "select * from " + DATA_TABLE_NAME + " where dat_job_id=" + jobId + " and dat_record_id >=" + startRecId + " and dat_record_id<=" + stopRecId + " order by dat_record_id";	     	                
		Statement stmt = dataTableConnObj.createStatement();
		ResultSet rs =stmt.executeQuery(getRecordQuery);
		while(rs.next())
		{
			jobId=rs.getInt(1);		            
			currentRecordId = rs.getInt(2);		            
			name =rs.getString(3);		           
			value = rs.getString(4);
			processRow(jobId, currentRecordId, name, value);
		}  //end while          
		finishUpLoadData(jobId, currentRecordId);
	}   	            	                                  
}



