/*********************************************** {COPYRIGHT-TOP} ***
* IBM Confidential
* OCO Source Materials
* 5724-V51
*
* (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
*
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has been
* deposited with the U.S. Copyright Office.
************************************************ {COPYRIGHT-END} **/




/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.mediator;

import java.util.ArrayList;
import com.ibm.ccd.ui.util.*;


/**
 * encapuslates the WPC soap  service response and provides the
 * data XML and attachments.
 */
public class SoapResponse {
   
	// WPC Axis SessionID
	private String wpcAxisSessionID; 
    
    // body xml 
    private String dataXML;

    // mime  attchments
    private ArrayList attachmentParts;

    public SoapResponse() {
    }

    public SoapResponse(String dataXML, ArrayList attachmentParts) {
        this.dataXML = dataXML;
        this.attachmentParts = attachmentParts;
    }

	public SoapResponse(String dataXML, ArrayList attachmentParts, String sessionID) {
		this.dataXML = dataXML;
		this.attachmentParts = attachmentParts;
		this.wpcAxisSessionID = sessionID;
	}

    public ArrayList getAttachmentParts() {
        return attachmentParts;
    }

    public String getDataXML() {
    	if(ConfigManager.getInstance().isAPIEnabled())
    	{    
    		
    		dataXML = dataXML.replaceAll("&lt;","<");
            dataXML = dataXML.replaceAll("&gt;",">");
            dataXML = dataXML.replaceAll("&quot;","\"");
            dataXML = dataXML.replaceAll("&amp;","&");
            dataXML = dataXML.replaceAll("xmlns=\"http://wpc.ibm.com\"","xmlns:wpc=\"http://wpc.ibm.com\"");
            dataXML = UIUtils.unescapeEntities(dataXML);
            System.out.println("Response is : " + dataXML);
          
    	
    	}
        return dataXML;
    }

    public void setAttachmentParts(ArrayList attachmentParts) {
        this.attachmentParts = attachmentParts;
    }

    public void setDataXML(String dataXML) {
        this.dataXML = dataXML;
    }
    
	public String getWpcAxisSessionID() {
		return wpcAxisSessionID;
	}

	public void setWpcAxisSessionID(String sessionID) {
		wpcAxisSessionID = sessionID;
	}

}
