/*********************************************** {COPYRIGHT-TOP} ***
* IBM Confidential
* OCO Source Materials
* 5724-V51
*
* (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
*
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has been
* deposited with the U.S. Copyright Office.
************************************************ {COPYRIGHT-END} **/




/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.taglib.dataobjects;

import java.util.HashMap;


/**
* SearchAttribute which represents the Text  Objects
* @author  IBM India
* @version 1.0
* @since   Iteration 2
**/
public class TextSearchElement extends BaseSearchElement implements Cloneable {
    /**
     * Identifier for default value
     */
    private String defValue;

    /**
     * Identifier for value
     */
    private String value;

    /**
     *Constructs an empty TextSearchElement
     **/
    public TextSearchElement() {
        super(ISearchElementTypesEnum.TEXT);
    }

    /**
     * Constructs the TextSearchElement for the specified name, oeprator, operatormap and madnadatory flag
     * @param aAttributeName
     * @param aDefaultValue
     * @param aDefaultOperator
     * @param aOperatorsMap
     * @param aIsMandatory
     * @param aIsDefaultable
     **/
    public TextSearchElement(String aAttributeName, String aDefaultValue,
        String aDefaultOperator, HashMap aOperatorsMap, boolean aIsMandatory,
        boolean aIsDefaultable) {
        super(ISearchElementTypesEnum.TEXT, aAttributeName, aDefaultOperator,
            aOperatorsMap, aIsMandatory, aIsDefaultable);
        this.defValue = aDefaultValue;
    }

    /**
     * Constructs the TextSearchElement for the specified name,value. oeprator, operatormap and madnadatory flag
     * @param aAttributeName
     * @param aDefaultValue
     * @param aDefaultOperator
     * @param aOperatorsMap
     **/
    public TextSearchElement(String aAttributeName, String aDefaultValue,
        String aDefaultOperator, HashMap aOperatorsMap) {
        this(aAttributeName, aDefaultValue, aDefaultOperator, aOperatorsMap,
            true, false);
    }

    /**
     *Returns the defautl text value associated with this
     *@return String, The default Value
     **/
    public String getDefaultValue() {
        return defValue;
    }

    /**
     *Returns the assgined text value associated with this
     *@return String, The Assigned Value
     **/
    public String getValue() {
        return value;
    }

    /**
     *Sets the defautl text value
     *@param aDefaultValue , The default Value
     **/
    public void setDefaultValue(String aDefaultValue) {
        this.defValue = aDefaultValue;
    }

    /**
     * Sets the assgined text value
     *@param aValue , The Assigned Value
     **/
    public void setValue(String aValue) {
        this.value = aValue;
    }

    /* (non-Javadoc)
     * @see com.ibm.ccd.ui.taglib.dataobjects.BaseSearchElement#clone()
     */
    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}
