/*********************************************** {COPYRIGHT-TOP} ***
* IBM Confidential
* OCO Source Materials
* 5724-V51
*
* (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
*
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has been
* deposited with the U.S. Copyright Office.
************************************************ {COPYRIGHT-END} **/




/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


/**
 * This class is the tag implementation of uilabel for displaying the label.
 * Tag Attributes:
 * key : required attribute for passing the key of label.
 */
package com.ibm.ccd.ui.tags;

import java.util.Locale;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import org.apache.jetspeed.portlet.PortletConfig;
import org.apache.jetspeed.portlet.PortletContext;
import org.apache.jetspeed.portlet.PortletRequest;

import com.ibm.ccd.ui.util.IReference;
import com.ibm.ccd.ui.util.UIUtils;


public class UITextMessageTag extends TagSupport implements ITagConstants {
    private String key = "";

    /**
    * doStartTag is called by the JSP container when the tag is encountered
    */
    public int doStartTag() {
        PortletConfig portletconfig = (PortletConfig) pageContext.getAttribute(VAR_PORTLET_CONFIG);
        PortletRequest portletRequest = (PortletRequest) pageContext.getAttribute(VAR_PORTLET_REQUEST);
        PortletContext portletContext = portletconfig.getContext();
        Locale locale = portletRequest.getLocale();

        try {
            JspWriter out = pageContext.getOut();

            if (getKey() == null) {
                key = "";
            }

            if (!(getKey().equals(""))) {
                try {
                    out.print(portletContext.getText(
                            IReference.BUNDLE_WPC_UI_LABELS, getKey(), locale));
                } catch (java.util.MissingResourceException m) {
                    portletContext.getLog().warn(UIUtils.getTextMessages(
                            portletContext, locale, "MESSAGE_CODE_54") + " :" +
                        key);
                    m.printStackTrace();
                }
            }
        } catch (Exception ex) {
            portletContext.getLog().error(UIUtils.getTextMessages(
                    portletContext, locale, "MESSAGE_CODE_53") + " " + ex);
            ex.printStackTrace();
        }

        return SKIP_BODY;
    }

    /**
     * @return string
     */
    public String getKey() {
        return key;
    }

    /**
     * @param string
     */
    public void setKey(String string) {
        key = string;
    }
}
