/*********************************************** {COPYRIGHT-TOP} ***
* IBM Confidential
* OCO Source Materials
* 5724-V51
*
* (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
*
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has been
* deposited with the U.S. Copyright Office.
************************************************ {COPYRIGHT-END} **/




/*
* Licensed Materials: Property of IBM
* "Restricted Materials of IBM"
* 5724-I68.
* (C) Copyright IBM Corp. 2000, 2005 - All Rights Reserved.
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*/


package com.ibm.ccd.ui.tags.element;

import org.apache.jetspeed.portlet.PortletURI;

import com.ibm.ccd.ui.dataobjects.attributes.Attribute;
import com.ibm.ccd.ui.dataobjects.attributes.SequenceAttribute;
import com.ibm.ccd.ui.util.UIUtils;


public class SequenceElement extends TextElement {
    public SequenceElement(Attribute attribute, PortletURI portletURI) {
        super(attribute, portletURI);
    }

    
    public String renderElement() {
        StringBuffer buffer = new StringBuffer();
        buffer.append(displayLabel());

        String value = ((SequenceAttribute) attribute).getValue();
        buffer.append(displayField(0, getStringValue(attribute, 0)));

        return buffer.toString();
    }

    /**
     * @param id
     * @param value
     * @return string
     */
    public String displayField(long id, Object value) {
        StringBuffer buffer = new StringBuffer();

        buffer.append(HTML_ATTRIBUTE_START);
		buffer.append(UIUtils.escapeForHTML((String)value));

        if (attribute.isMultiValued()) {
            buffer.append(displayPlusMinus(id));
        }

        buffer.append(HTML_ATTRIBUTE_END);

        return buffer.toString();
    }
}
